#############################################################
#                       ucan-host-ipfs                      #
#  https://gitlab.com/wovin/deploy/template/docker-compose  #
#############################################################

{% if http_mode == 'caddy' -%}
volumes:
    caddy_data:
    caddy_config:

{% endif -%}
services:
    
    {%- if http_mode == 'caddy' %}
    caddy:
        image: caddy:2  # https://hub.docker.com/_/caddy
        restart: always
        volumes:
            - ./Caddyfile:/etc/caddy/Caddyfile:ro
            - caddy_data:/data # Required to be persistent
            - caddy_config:/config # optional, but convenient
        ports:
          - 80:80
          - 443:443
    {% endif %}
    kubo:
        image: ipfs/kubo  # https://hub.docker.com/r/ipfs/kubo
        restart: always
        environment:
            IPFS_PATH: /data/ipfs
            IPFS_PROFILE: '' # https://github.com/ipfs/kubo/blob/master/docs/config.md#profiles
        volumes:
            - ./config/kubo-config.sh:/container-init.d/kubo-config.sh:ro
            - ./ipfs-data:/data/ipfs
        ports:
            {% if http_mode == 'no_proxy' -%}
            # HTTP Gateway
            {% if not enable_gateway %}# {% endif %}- 8080:8080

            {% endif -%}
            # 'Swarm' ports for connecting to the IPFS network - listens on all interfaces, so it's remotely reachable (if you have a public IP).
            - 4001:4001/tcp
            - 4001:4001/udp

            # The following ports only listen on the loopback interface, so are not remotely reachable.
            # API port, which includes admin operations, so don't make this publically accessible!
            - 127.0.0.1:5001:5001

    {% if enable_ucan -%}
    ucan-proxy:
        image: registry.gitlab.com/wovin/deploy/ucan-store-proxy:latest # https://gitlab.com/wovin/deploy/ucan-store-proxy
        restart: always
        environment:
            UCAN_KUBO_RPC: http://kubo:5001
            UCAN_PUBLIC_URL: {{ public_ucan_url }}
            UCAN_GATEWAY_PUBLIC_URL: {{ public_gateway_url }}
            # UCAN_TRUSTED_DIDS: >-
            #    did:key:YOUR,
            #    did:key:TRUSTED_KEYS,
            #    did:key:HERE
        {% if http_mode == 'no_proxy' -%}
        ports:
            - 8000:8000
        {%- endif %}
    {%- endif %}

